                                                                              
/******************************************************************************
 *                             Multi-Include-Prevent                          *
 ******************************************************************************/
#ifndef _COMMON_H_                                                                
#define _COMMON_H_                                                                
                                                                               
/******************************************************************************
 *                              Debug Switch Section                          *
 ******************************************************************************/

/******************************************************************************
 *                             Include File Section                           *
 ******************************************************************************/

/******************************************************************************
 *                          Pubilc Macro Define Section                       *
 ******************************************************************************/
#define SOFTWARE_VERSION  0x0100UL       //  汾(2ֽ) V1.0
#define HARDWARE_VERSION  0x0100UL       //  Ӳ汾(2ֽ) V1.0
#define MANUFACTORY_ID    0x00000001UL   //  ̴(4ֽ)

/*Data type definition*/
typedef unsigned char          uint8;
typedef signed char            int8;
typedef unsigned short int     uint16;
typedef signed short int       int16;
typedef unsigned long int      uint32;
typedef signed long int        int32;
typedef unsigned long long int uint64;
typedef signed long long int   int64;

#ifndef NULL 
#define NULL                   0
#endif

#ifndef bool
#define bool                   uint8
#endif

#ifndef FALSE
#define FALSE                  0
#endif

#ifndef TRUE
#define TRUE                   1
#endif

/*Bit opration*/
#define BITSET(var,bitno)      ((var) |= (1 << (bitno)))
#define BITCLR(var,bitno)      ((var) &= ~(1 << (bitno)))
#define BITTST(var,bitno)      (var & (1 << (bitno)))
#define BIT(x)                 (1 << (x))

/******************************************************************************
 *                             Struct Define Section                          *
 ******************************************************************************/
typedef enum{SUCCEED = 1, FAILURE = !SUCCEED} en_OperResult;
typedef enum{LOW_LEVEL=0, HIGH_LEVEL=1} en_Level;

/******************************************************************************
 *                        Global Variable Declare Section                     *
 ******************************************************************************/

/******************************************************************************
 *                            Function Declare Section                        *
 ******************************************************************************/
uint8  comCheckSum(uint8 const *pcBuffer, uint8 ucLength, uint8 ucOffset);
uint16 comCalCRC16(uint8 *pucBuf, uint16 uwLength); // CRC-16У
void  *comMEMCPY(void *dest, const void *src, unsigned int n);
void  *comMEMSET(void *pbuf, int value, unsigned int n);
int    comMEMCMP(const void *buf1, const void *buf2, unsigned int n);
void   comSrand(uint32 u32Seed);     // 
uint16 comRand(uint16 uwMax);        // һ1--max֮

#endif                                                                         


