                                                                               
#define _SPI_C_                                                                
                                                                               
/******************************************************************************
 *                             Include File Section                           *
 ******************************************************************************/
#include  "spi.h" 
                                                                               
/******************************************************************************
 *                         Private Macro Define Section                       *
 ******************************************************************************/
                                                                               
/******************************************************************************
 *                             Struct Define Section                          *
 ******************************************************************************/
                                                                               
/******************************************************************************
 *                           Prototype Declare Section                        *
 ******************************************************************************/
static uint8 spiSendOneByte(uint8 addr);
                                                                               
/******************************************************************************
 *                        Global Variable Declare Section                     *
 ******************************************************************************/
                                                                               
/******************************************************************************
 *                     File Static Variable Declare Section                   *
 ******************************************************************************/
                                                                               
/******************************************************************************
 *                           Function Declare Section                         *
 ******************************************************************************/
/*============================== External Function ===========================*/
/****************************************************************
 * Function Name: halSpiInit
 * Decription   : 
 * Calls        : 
 * Called By    : 
 * Input        : None
 * Output       : None
 * Return Value : None
 * Others       : None
 *------------------------- Revision History -------------------
 * No. Version Date      Revised by   Item      Description     
 * 1   V1.0    2011-1-23    AdhocNet               
 *****************************************************************/
void halSpiInit(void)
{
    unSsu_MstcrReg    unmstcr_reg;
    unSsu_Ssbr_Reg    unssbr_reg;
    unSsu_Sscrh_Reg   unsscrh_reg;
    unSsu_Ssmr2_Reg   unssmr2_reg;
    unSsu_Ssmr_Reg    unssmr_reg;
    unSsu_SsuiicsrReg unssuiicsr;

    SPI_CS_DIR = OUTPUT;
    SPI_CS     = HIGH;

    SPI_TX_DISABLE;
    SPI_RX_DISABLE;

    unmstcr_reg.stmstcr.IicSsuEn = 0;
    
    unssbr_reg.stssbr.Send_Bits  = SPI_SEND_8BITS;

    unsscrh_reg.stsscrh.CLK_SEL  = SPI_CLK_F1_4;
    unsscrh_reg.stsscrh.M1_OR_S0 = 1;
    unsscrh_reg.stsscrh.RSTOP1   = 1;

    unssmr2_reg.stssmr2.FourWire1_Sel = 0;  //ѡͨѶ?    unssmr2_reg.stssmr2.SCS_CMOS_N1 = 0;
    unssmr2_reg.stssmr2.SO_CMOS_N1    = 0;
    unssmr2_reg.stssmr2.SCK_CMOS_N1   = 0;
    unssmr2_reg.stssmr2.SCS_CMOS_N1   = 0;
    unssmr2_reg.stssmr2.CS_Config     = SPI_CS_PORT;
    unssmr2_reg.stssmr2.BIDE_TWO1_ONE = 1;
    unssmr2_reg.stssmr2.SCK_PORT0_CLOCK1 = 1;
    
    unssmr_reg.stssmr.Even1_Odd0_Change = 0;
    unssmr_reg.stssmr.High0_Low1_Stop   = 0;
    unssmr_reg.stssmr.MSB0_LSB1_First   = 0;
    unssuiicsr.stssuiicsr.Iic1_Ssu0_Sel = 0;  // ѡͬͨŵԪģʽ
    
    mstcr    = unmstcr_reg.MstcrReg;
    ssbr     = unssbr_reg.Ssbr_Reg;
    sscrh    = unsscrh_reg.Sscrh_Reg;
    ssmr2    = unssmr2_reg.Ssmr2_Reg;
    ssmr     = unssmr_reg.Ssmr_Reg;
    ssuiicsr = unssuiicsr.SsuiicsrReg;
}

/****************************************************************
 * Function Name: spiWriteAddrByte
 * Decription   : ͨSPIӿַָдһֽڵֵ
 * Calls        : 
 * Called By    : 
 * Input        : None
 * Output       : None
 * Return Value : None
 * Others       : None
 *------------------------- Revision History -------------------
 * No. Version Date      Revised by   Item      Description     
 * 1   V1.0    2011-1-23    AdhocNet               
 *****************************************************************/
void spiWriteAddrByte(uint8 address,uint8 data)
{
    DISABLE_INTERRUPT;
    SPI_CS = LOW;     
    spiSendOneByte(address|0x80);
    spiSendOneByte(data);  
    SPI_CS = HIGH;
    ENABLE_INTERRUPT;
}

/****************************************************************
 * Function Name: spiReadAddrByte
 * Decription   : ͨSPIӿڶȡֵַָ
 * Calls        : 
 * Called By    : 
 * Input        : None
 * Output       : None
 * Return Value : None
 * Others       : None
 *------------------------- Revision History -------------------
 * No. Version Date      Revised by   Item      Description     
 * 1   V1.0    2011-1-23    AdhocNet               
 *****************************************************************/
uint8 spiReadAddrByte(uint8 addr)
{
    uint8 temp;  

    DISABLE_INTERRUPT;
    SPI_CS = LOW; 
    spiSendOneByte(addr);
    temp = spiSendOneByte(0);
    SPI_CS = HIGH;
    ENABLE_INTERRUPT;

    return temp;
}

/*============================== Internal Function ===========================*/
/****************************************************************
 * Function Name: spiSendOneByte
 * Decription   : ͨSPIӿڶдһֽ
 * Calls        : 
 * Called By    : 
 * Input        : None
 * Output       : None
 * Return Value : None
 * Others       : None
 *------------------------- Revision History -------------------
 * No. Version Date      Revised by   Item      Description     
 * 1   V1.0    2011-1-23    AdhocNet               
 *****************************************************************/
static uint8 spiSendOneByte(uint8 addr)
{
   uint8 temp;

   SPI_TX_ENABLE;
   SPI_RX_ENABLE; 
   temp = SPI_RX_BUF;              // 
   while(SPI_IS_TX_BUF_EMPTY==0);  // ȴͻ
   sstdr = addr;
   while(SPI_IS_TX_END==0);
   SPI_CLR_TX_END;
   while(SPI_IS_RX_END==0);
   temp = SPI_RX_BUF;

   return temp;
}



