                                                                               
/******************************************************************************
 *                             Multi-Include-Prevent                          *
 ******************************************************************************/
#ifndef _UART_H_                                                                
#define _UART_H_                                                                
                                                                               
/******************************************************************************
 *                              Debug Switch Section                          *
 ******************************************************************************/
                                                                               
/******************************************************************************
 *                             Include File Section                           *
 ******************************************************************************/
#include "common.h"
#include "hal.h"

/******************************************************************************
 *                          Pubilc Macro Define Section                       *
 ******************************************************************************/
#ifdef _UART_C_
#define UART_EXT
#else
#define UART_EXT extern
#endif

//ڽݴ־,uirb8λд±־
#define UART_ERROR_OVERFLOW    0x10     
#define UART_ERROR_FRAME       0x20
#define UART_ERROR_PARITY      0x40
#define UART_ERROR_SUM         0x80

//ݸʽú궨
//for UiMR
#define UART_PARITY_NONE       0x00   /*У*/
#define UART_PARITY_ODD        0x40   /*У*/
#define UART_PARITY_EVEN       0x60   /*żУ*/

#define UART_BITS_9            0x06 /*ھλ*/
#define UART_BITS_8            0x05 /*8λ*/
#define UART_BITS_7            0x04 /*7λ */

#define UART_STOP_BIT_ONE      0x00 /*1ֹͣλ*/
#define UART_STOP_BIT_TWO      0x10 /*1ֹͣλ*/

#define UART_CLK_IN            0X00
#define UART_CLK_OUT           0X80

//for UiC0
#define UART_MSB_LAST          0x00 /*λ*/
#define UART_MSB_FIRST         0x80 /*λ*/

#define UART_CLK_F1            0X00
#define UART_CLK_F8            0X01
#define UART_CLK_F32           0X02
#define UART_CLK_FC            0X03

#define UART_TXD_OPEN          0X20

//for  uosr
#define UART_USE_TXD            0X01
#define UART_USE_RXDTOP114      0X08
#define UART_USE_RXDTOP132      0X04
#define UART_USE_CLK            0X10

#define UART_TX_ENABLE(uart)    do{ u##uart##c1 |= 0x01; }while(0)
//ڷͽֹ  
#define UART_TX_DISABLE(uart)   do{ u##uart##c1 &= ~0x01;}while(0)

//ڽʹ
#define UART_RX_ENABLE(uart)    do { u##uart##c1 |= 0x04;}while(0)
//ڽսֹ
#define UART_RX_DISABLE(uart)   do { u##uart##c1 &= ~0x04;}while(0)

#define UART_RX_IT_OPEN          s0ric=0x05
#define UART_RX_IT_CLOSE         s0ric=0

#define UART_TX_IT_OPEN          s0tic=0x05
#define UART_TX_IT_CLOSE         s0tic=0

#define UART_RX_OVER_TIME        15    // жϴڽɵĳʱʱ(ms)
#define UART_BUF_SIZE            255

/******************************************************************************
 *                             Struct Define Section                          *
 ******************************************************************************/
typedef struct
{
    uint8  RxOK:1;       // ɱ־λ   0:ڽ    1:
    uint8  u8Timer:7;    // ʱ 0x7F:ճʱ :ڽ
    uint16 u16Count;     // ڽbufЧֽ
    uint8  Buf[UART_BUF_SIZE];  // ڽbuf
} st_Uart;

extern st_Uart stUart;
                                                                   
/******************************************************************************
 *                        Global Variable Declare Section                     *
 *****************************z*************************************************/
                                                                   
/******************************************************************************
 *                            Function Declare Section                        *
 ******************************************************************************/
UART_EXT bool  Uart_SendData(const uint8 *ptr, uint8 len);
UART_EXT void  Uart_Putc(uint8 c);
//UART_EXT int putchar(int c);

#endif                                                                         
