                                                                               
/******************************************************************************
 *                             Include File Section                           *
 ******************************************************************************/
#include "hal.h"
#include "uart.h"
#include "rf.h"


/******************************************************************************
 *                         Private Macro Define Section                       *
 ******************************************************************************/

/******************************************************************************
 *                             Struct Define Section                          *
 ******************************************************************************/
                                                                               
/******************************************************************************
 *                           Prototype Declare Section                        *
 ******************************************************************************/
static void systemInit(void);

/******************************************************************************
 *                        Global Variable Declare Section                     *
 ******************************************************************************/

/******************************************************************************
 *                     File Static Variable Declare Section                   *
 ******************************************************************************/
#define APP_BUF_SIZE 200
typedef struct
{
    uint8  RxOK;               // ɱ־λ   0:ڽ    1:
    uint16 u16Count;           // bufЧֽ
    uint8  Buf[APP_BUF_SIZE];  // buf
} st_App;

st_App stApp;

/******************************************************************************
 *                           Function Declare Section                         *
 ******************************************************************************/
/****************************************************************
 * Function Name: main
 * Decription   : ʵϵͳĲԡӦõй
 * Calls        : 
 * Called By    : None
 * Input        : None
 * Output       : None
 * Return Value : None
 * Others       : while(1)ʵַʽ:תƱ, ڹģʽл
 *------------------------- Revision History -------------------
 * No. Version Date      Revised by   Item      Description     
 * 1   V1.0    2011-2-18     Original Version 
 *****************************************************************/
void main(void)
{
    systemInit();
    
    while(1)
    {
        if(stUart.RxOK)
        {
            stUart.RxOK = 0;
            rfTx(stUart.Buf, stUart.u16Count);
            stUart.RxOK     = 0;
            stUart.u16Count = 0;
        }
        
        if(stApp.RxOK)
        {
            Uart_SendData(stApp.Buf, stApp.u16Count);
            stApp.RxOK    = 0;
            stApp.u16Count = 0;
        }
    }
}


/****************************************************************
 * Function Name: systemInit
 * Decription   : ʼCPUϵͳҪ
 * Calls        : 1mcuInit()
 * Called By    : main()
 * Input        : None
 * Output       : None
 * Return Value : None
 * Others       : 
 *------------------------- Revision History -------------------
 * No. Version Date      Revised by   Item      Description     
 * 1   V1.0    2011-2-18     Original Version              
 *****************************************************************/
static void systemInit(void)
{
    DISABLE_INTERRUPT;
    halMCUInit();
    rfInit();
    ENABLE_INTERRUPT; 
}

/****************************************************************
* Function Name: rfRx
* Decription   :
* Calls        :
* Called By    :
 * Input        : pbuf    : ָPHYջָ
                  u8Len   : PSDUĳ
                  u8RSSI  : ո֡źֵ(ֵԽСŵԽ)
* Output       :
* Return Value :
* Others       :
*------------------------- Revision History -------------------
* No. Version Date      Revised by   Item      Description     
* 1   V1.0    02/18/2011                  
*****************************************************************/
void rfRx( uint8 *pbuf,
           uint8  u8Len,
           uint8  u8RSSI)          // dbm ֵԽСŵԽ
{
    if(!stApp.RxOK)
    {
        stApp.RxOK     = 1;
        stApp.u16Count = u8Len;
        comMEMCPY(stApp.Buf, pbuf, u8Len);
    }
}

/***************** (C) COPYRIGHT 2011  Tech ***********END OF FILE*******/
