
#define _RF_C_                                                                

/******************************************************************************
*                             Include File Section                           *
******************************************************************************/
#include "rf.h" 

/******************************************************************************
*                         Private Macro Define Section                       *
******************************************************************************/
#define  TEST_FREQ           0xFD            // Ƶ 480.2MHz
#define  RF_RSSI_THR         95              // 㹫ʽ:|INPUT POWER(dbm)|=129-0.5*RF_RSSI_TH
#define  RF_PACKET_EXTENSION 10              // ÿ֡ݶ෢RF_PACKET_EXTENSION BitЧλ֤Ϳɿ

#define  RF_CHANNEL_GRP_NUM  17
#define  RF_FREQ_DOT_NUM     3
#define  RF_FREQ_REG_NUM     3

/******************************************************************************
*                             Struct Define Section                          *
******************************************************************************/
typedef enum
{
    RF_RX_PREAMBLE,     /*ɨǰ*/
    RF_RX_SYNC_WORD,    /*ͬ    */
    RF_RX_PAYLOAD,      /*Чغ  */
    RF_TX_PREAMBLE,     /*ǰ    */
    RF_TX_SYNC_WORD,    /*ͬ    */
    RF_TX_PAYLOAD,      /*Чغ  */
} en_RfFsm;

typedef union
{
    uint8 ShiftReg;
    
    struct 
    {
        uint8 ShiftRegLSB    :1;
        uint8                :1;
        uint8                :1;
        uint8                :1;
        uint8                :1;
        uint8                :1;
        uint8                :1;
        uint8 ShiftRegMSB    :1;
    };
}un_ShiftReg;

/******************************************************************************
*                           Prototype Declare Section                        *
******************************************************************************/
static bool rfSetDeviation(uint32 dev);
//static void rfSetBandwidth(uint8 bw);
static void rfGetITStatus(void);

/******************************************************************************
*                        Global Variable Declare Section                     *
******************************************************************************/
st_RfBuf rfBuf;

/******************************************************************************
*                     File Static Variable Declare Section                   *
******************************************************************************/
//static uint8 uiRfItStatus1;
static uint8       uiRfItStatus2;
static uint16      uiPreambleLength = 0;
static en_RfFsm    enRfFsm = RF_RX_PREAMBLE;
static un_RfFlg    unRfFlg; 

static uint8       ucBitCnt   = 0;     // /Bit
static uint16      uiByteCnt  = 0;     // /Byte

/******************************************************************************
*                           Function Declare Section                         *
******************************************************************************/
/*============================== External Function ===========================*/
/****************************************************************
* Function Name: rfInit
* Decription   :
* Calls        :
* Called By    :
* Input        :
* Output       :
* Return Value :
* Others       :
*------------------------- Revision History -------------------
* No. Version Date      Revised by   Item      Description     
* 1   V1.0    2011-2-18                   
*****************************************************************/
void rfInit(void)
{
    LED_ON_ALL;
    SDN = 1;
    halWait(200);
    halWait(200);
    SDN = 0;
    halWait(200);
    halWait(200);

    unRfFlg.RfFlg    = 0;
    uiPreambleLength = 0;
    enRfFsm          = RF_RX_PREAMBLE;
        
    do
    {
        rfGetITStatus();
    }
    while((uiRfItStatus2&0x02==0)||(uiRfItStatus2==0xff));
    
    spiWriteAddrByte(OperatingFunctionControl1 , 0x80); 
    while(NIRQ_INPUT_PIN == 1);     
    //read interrupt status registers to clear the interrupt flags and release NIRQ pin
    rfGetITStatus();
    
    rfSetFreq(0xFF);

    spiWriteAddrByte(TXDataRate1, 0x51);                                                        
    spiWriteAddrByte(TXDataRate0, 0xEc);  //10K
    spiWriteAddrByte(ModulationModeControl1, 0x2C);              //?                                                

    /*
    spiWriteAddrByte(TXDataRate1, 0x13);                                                        
    spiWriteAddrByte(TXDataRate0, 0xA9);  //2.4K
    spiWriteAddrByte(ModulationModeControl1, 0x2C);              //?
    */
      
    //  spiWriteAddrData(PreambleLength, 0);                        //write 0x18 to the Preamble Length register    
    
    spiWriteAddrByte(PreambleDetectionControl, 0x28);                                                       //write 0x28 to the Preamble Detection Control  register
    
    //Disable the receive header filters
    //Disable header bytes; set variable packet length (the length of the payload is defined by the
    //received packet length field of the packet); set the synch word to two bytes long
    //  spiWriteAddrData(HeaderControl1, 0X00);
    //  spiWriteAddrData(HeaderControl2, SYNC_TWO_LENGTH);                                                      //write 0x02 to the Header Control2 register    
    
    //Set the sync word pattern to 0x0000
    spiWriteAddrByte(SyncWord3, RF_SYNC1);      
    spiWriteAddrByte(SyncWord2, RF_SYNC2);  
    
    //set the threshold of RSSI
    spiWriteAddrByte(RSSIThresholdForClearChannelIndicator, RF_RSSI_THR);   // CCAֵ
    
    
    // ֱͨģʽ޸
    // spiWriteAddrData(DataAccessControl, LSBFIRST);  
    /******************************************************************************
    *           GPIO2ΪCLKGPIO1Ϊ                      *
    ******************************************************************************/
    //write 0x63 to the Modulation Mode Control 2 register
    spiWriteAddrByte(ModulationModeControl2, GFSK|DIRECTMOD_VIA_GPIO|TXCLK_VIA_GPIO);
    spiWriteAddrByte(GPIO1Configuration,GPIO_TX_DATA_CLK|0x20);

    spiWriteAddrByte(GPIO0Configuration,0X0A); //
    
    /*set the non-default Si4432 registers*/
/*
    //set the VCO and PLL
    spiWriteAddrByte(VCOCurrentTrimming, 0x7F);                                                         //write 0x7F to the VCO Current Trimming register 
    spiWriteAddrByte(ChargepumpCurrentTrimming_Override, 0x80);                                                     //write 0x80 to the ChargepumpCurrentTrimmingOverride register
    spiWriteAddrByte(DividerCurrentTrimming, 0x40);                                                     //write 0x40 to the Divider Current Trimming register   
    //set the AGC
    spiWriteAddrByte(AGCOverride2, 0x0B);                                                   //write 0x0B to the AGC Override 2 register

    //set ADC reference voltage to 0.9V
    spiWriteAddrByte(DeltasigmaADCTuning2, 0x04);                                                       //write 0x04 to the Deltasigma ADC Tuning 2 register
    spiWriteAddrByte(ClockRecoveryGearshiftOverride, 0x03);                                                     //write 0x03 to the Clock Recovery Gearshift Override register
*/
#if DEVICE_TYPE_ == COORDINATOR
    spiWriteAddrByte(CrystalOscillatorLoadCapacitance, 0);  
#elif DEVICE_TYPE_ == ENDDEVICE
    spiWriteAddrByte(CrystalOscillatorLoadCapacitance, 0x1f);   
#endif          
    spiWriteAddrByte(0x56, 0x40);
    spiWriteAddrByte(0x33, 0x80);
    
    //receive data 10k ,frequency deviation 25khz
    spiWriteAddrByte(0x58, 0x80);
    spiWriteAddrByte(0x1c, 0x16);
    spiWriteAddrByte(0x20, 0xc8);
    spiWriteAddrByte(0x21, 0x00);
    spiWriteAddrByte(0x22, 0xa3);
    spiWriteAddrByte(0x23, 0xd7);
    spiWriteAddrByte(0x24, 0x00);
    spiWriteAddrByte(0x25, 0x85);
    /*   spiWriteAddrData(0x1d, 0x40);
    spiWriteAddrData(0x1e, 0x0a);
    spiWriteAddrData(0x2a, 0x21);
    spiWriteAddrData(0x1f, 0x03);
    spiWriteAddrData(0x69, 0x60);*/
    spiWriteAddrByte(0x1d, 0x3c);
    spiWriteAddrByte(0x1e, 0x02);
    spiWriteAddrByte(0x2a, 0xff);
    spiWriteAddrByte(0x1f, 0x03);
    spiWriteAddrByte(0x69, 0x60);
    
    rfSetDeviation(25000);
    //  rfSetBandwidth( RFBW_692);                                          //write 0x1F to the Frequency Deviation register        
    
    rfSetTxPower(PA_17DBM);

    #if DEVICE_TYPE_ == COORDINATOR
        LED_CH_GREEN_OFF;
        LED_CH_RED_OFF;
        LED_RF_RX_OFF;
        LED_RF_TX_OFF;  
    #elif DEVICE_TYPE_ == ENDDEVICE
        LED_OFF_ALL;  
    #endif
    rfStartRx();
}

/****************************************************************
 * Function Name: rfSetPrmbleLength
 * Decription   : ÷ʱǰ볤
 * Calls        :
 * Called By    :
 * Input        :
 * Output       :
 * Return Value :
 * Others       :
 *------------------------- Revision History -------------------
 * No. Version Date      Revised by    Item      Description     
 * 1   V1.0    2011-4-10      Original Version 
 *****************************************************************/
void rfSetPrmbleLength(uint16 uiPrmbleLen)
{
    uiPreambleLength = uiPrmbleLen;
}

/****************************************************************
* Function Name: rfStartTx
* Decription   : ߷(֮ǰѾݺͳдstRfBuf)
* Calls        :
* Called By    :
* Input        : None
* Output       : None
* Return Value : None
* Others       :
*------------------------- Revision History -------------------
* No. Version Date      Revised by    Item      Description     
* 1   V1.0    2011-4-7      Original Version 
*****************************************************************/
bool rfStartTx(void)
{ 
    enRfFsm             = RF_TX_PREAMBLE;
    unRfFlg.RfFlg       = 0;
    ucBitCnt            = 0;
    uiByteCnt           = 0;
    
    RF_LNA_OFF;   
    RF_DIRECT_TX;   
    RF_PA_ON; 
    RF_BIT_TX_INT_ON;    
    return TRUE;
}

/****************************************************************
 * Function Name: rfStartRx
 * Decription   : ߽
 * Calls        :
 * Called By    :
 * Input        :
 * Output       :
 * Return Value :
 * Others       :
 *------------------------- Revision History -------------------
 * No. Version Date      Revised by    Item      Description     
 * 1   V1.0    2011-4-10      Original Version 
 *****************************************************************/
void rfStartRx(void)
{
    enRfFsm         = RF_RX_PREAMBLE; 
    rfBuf.Length    = 0;
    unRfFlg.RfFlg   = 0;
    RF_PA_OFF;
    RF_DIRECT_RX;
    RF_LNA_ON;
    RF_BIT_RX_INT_ON;
}

/****************************************************************
 * Function Name: rfStop
 * Decription   : ֹͣշ
 * Calls        :
 * Called By    :
 * Input        :
 * Output       :
 * Return Value :
 * Others       :
 *------------------------- Revision History -------------------
 * No. Version Date      Revised by    Item      Description     
 * 1   V1.0    2011-4-10      Original Version 
 *****************************************************************/
void rfStop(void)
{
    RF_BIT_INT_OFF;
    rfBuf.Length    = 0;
    unRfFlg.RfFlg   = 0;
}

/****************************************************************
* Function Name: rfGetState
* Decription   : жRF״̬Ƿ
* Calls        :
* Called By    :
* Input        :
* Output       :
* Return Value :
* Others       :
*------------------------- Revision History -------------------
* No. Version Date      Revised by   Item      Description     
* 1   V1.0    2011-2-18                   
*****************************************************************/
un_RfFlg rfGetState(void)
{
    // ڽ״̬ûյȷУ˵RFУ
    if(  (RF_RX_PREAMBLE == enRfFsm)
      && (!unRfFlg.PreambleFound))
    {
        unRfFlg.RFBusy = FALSE;
    }
    else
    {
        unRfFlg.RFBusy = TRUE;
    }
    return unRfFlg;
}

/****************************************************************
 * Function Name: rfBitIntHandlerSimple
 * Decription   :
 * Calls        :
 * Called By    :
 * Input        :
 * Output       :
 * Return Value :
 * Others       :
 *------------------------- Revision History -------------------
 * No. Version Date      Revised by    Item      Description     
 * 1   V1.0    2011-4-10      Original Version 
 *****************************************************************/
void rfBitIntHandlerSimple(void)
{   
    static un_ShiftReg unShiftReg = {0};     // ֱͨģʽ£/ʱλĴ

    switch(enRfFsm)
    {
        case RF_RX_PREAMBLE:
            unShiftReg.ShiftReg  >>= 1;
            unShiftReg.ShiftRegMSB = GP_RX_DAT;
            
            if(!unRfFlg.PreambleFound)       // 4
            {
                if(  (RF_PRE1 == unShiftReg.ShiftReg)
                   ||(RF_PRE2 == unShiftReg.ShiftReg))
                {
                    uiByteCnt++;
                }
                else
                {
                    uiByteCnt = 0;
                }

                if(uiByteCnt >= RF_PREAMBLE_NUM)
                {
                    uiByteCnt              = 0;
                    unRfFlg.PreambleFound  = TRUE;
                    //rfBuf.u8RSSI           = rfGetRssi();
                }
            }
            else
            {
                if(RF_SYNC1 == unShiftReg.ShiftReg)
                {
                    uiByteCnt = 0;
                    ucBitCnt  = 0;
                    //unRfFlg.PreambleFound  = FALSE;
                    enRfFsm   = RF_RX_SYNC_WORD;
                }
                else if((RF_PRE1 == unShiftReg.ShiftReg)||(RF_PRE2 == unShiftReg.ShiftReg))
                {
                }
                else if(0 == uiByteCnt) 
                {
                    uiByteCnt++;
                }
                else
                {
                }

                if(uiByteCnt > 0)
                    uiByteCnt++;
                
                if(uiByteCnt > 10)
                {
                    uiByteCnt             = 0;
                    unRfFlg.PreambleFound = FALSE;
                }
            }
            break;

        case RF_RX_SYNC_WORD: 
            unShiftReg.ShiftReg  >>= 1;
            unShiftReg.ShiftRegMSB = GP_RX_DAT;
            ucBitCnt++;
            
            if(ucBitCnt >= 8)
            {
                ucBitCnt = 0;
                if(RF_SYNC2 == unShiftReg.ShiftReg)
                {
                    unRfFlg.SYNCFound     = TRUE;
                    rfBuf.Length          = 0;
                    rfBuf.TotalLength     = RF_MAX_SIZE;
                    enRfFsm               = RF_RX_PAYLOAD;
                }
                else
                {
                    unRfFlg.PreambleFound = FALSE;
                    enRfFsm               = RF_RX_PREAMBLE;
                }
            }
            break;
            
        case RF_RX_PAYLOAD:
            unShiftReg.ShiftReg  >>= 1;
            unShiftReg.ShiftRegMSB = GP_RX_DAT;
            ucBitCnt++;

            if(ucBitCnt >= 8)
            {
                ucBitCnt = 0;
                
                if((rfBuf.Length + 1) < rfBuf.TotalLength)
                {
                    rfBuf.Buf[rfBuf.Length++] = unShiftReg.ShiftReg;
                    if(rfBuf.Length == RF_HEADER_LEN)
                    {
                        rfBuf.TotalLength = rfBuf.Buf[RF_OFFSET_LEN] + RF_HEADER_LEN;
                        if(rfBuf.TotalLength > RF_MAX_SIZE)
                        {
                            rfStartRx();
                        }
                    }
                }
                else
                {
                    rfBuf.Buf[rfBuf.Length++] = unShiftReg.ShiftReg;
                    rfRx(&rfBuf.Buf[RF_HEADER_LEN], rfBuf.Buf[RF_OFFSET_LEN], rfBuf.u8RSSI);
                    rfStartRx();
                }
            }
            break;
            
        case RF_TX_PREAMBLE:
            if((0 == uiByteCnt)&&(0 == ucBitCnt))
            {
                unShiftReg.ShiftReg = RF_PRE1;
                uiByteCnt++;
            }
            else if((uiByteCnt < uiPreambleLength) && (ucBitCnt >= 8))
            {
                unShiftReg.ShiftReg = RF_PRE1;
                ucBitCnt = 0;
                uiByteCnt++;
            }

            GP_TX_DAT              = unShiftReg.ShiftRegLSB;
            unShiftReg.ShiftReg  >>= 1;
            ucBitCnt++;

            if((uiByteCnt >= uiPreambleLength) && (ucBitCnt >= 8))
            {
                ucBitCnt  = 0;
                uiByteCnt = 0;
                enRfFsm   = RF_TX_SYNC_WORD;
            }
            break;
            
        case RF_TX_SYNC_WORD: 
            if((0 == uiByteCnt) && (0 == ucBitCnt))
            {   // ׼͵һֽͬ
                unShiftReg.ShiftReg  = RF_SYNC1;
                uiByteCnt++;
            }
            else if((1 == uiByteCnt) && (ucBitCnt >= 8))
            {   // һֽͬڷϣ׼͵ڶͬ
                unShiftReg.ShiftReg  = RF_SYNC2;
                ucBitCnt = 0;
                uiByteCnt++;
            }
            
            GP_TX_DAT              = unShiftReg.ShiftRegLSB;
            unShiftReg.ShiftReg  >>= 1;
            ucBitCnt++;
            
            if((2 == uiByteCnt) && (ucBitCnt >= 8))
            {   // ڶַͬϣ׼PHY֡
                ucBitCnt  = 0;
                uiByteCnt = 0;
                enRfFsm   = RF_TX_PAYLOAD;
            }
            break;
        
        case RF_TX_PAYLOAD:
            if((0 == uiByteCnt) && (0==ucBitCnt))
            {   // ׼͵һֽ
                unShiftReg.ShiftReg     = rfBuf.Buf[uiByteCnt];
                unRfFlg.LastByteSendEnd = FALSE;
                uiByteCnt++;
            }
            else if((uiByteCnt < rfBuf.Length) && (ucBitCnt >= 8))
            {
                unShiftReg.ShiftReg = rfBuf.Buf[uiByteCnt];
                ucBitCnt = 0;
                uiByteCnt++;
            }
            else if((uiByteCnt >= rfBuf.Length) && (ucBitCnt >= 8) && !(unRfFlg.LastByteSendEnd))
            {
                ucBitCnt                = 0;
                unRfFlg.LastByteSendEnd = TRUE;
                unShiftReg.ShiftReg     = 0x00;
            }
            else if(unRfFlg.LastByteSendEnd)
            {   // һֽڷ͸RFоƬ֮ٷͼBit
                if(ucBitCnt > RF_PACKET_EXTENSION)
                {
                    //uiByteCnt             = 0;
                    ucBitCnt                = 0;
                    //unRfFlg.PayloadSendEnd  = TRUE;
                    rfStartRx();   // ɺ֪ͨPHYɨƵ״̬
                }
            }
            
            GP_TX_DAT              = unShiftReg.ShiftRegLSB;
            unShiftReg.ShiftReg  >>= 1;
            ucBitCnt++;
            break;

        default:
            ucBitCnt  = 0;
            uiByteCnt = 0;
            rfStartRx();
            break;
    }
}

/*============================== Internal Function ===========================*/
/****************************************************************
* Function Name: rfGetITStatus
* Decription   : ȡ4432״̬Ĵ
* Calls        :
* Called By    :
* Input        :
* Output       :
* Return Value :
* Others       :
*------------------------- Revision History -------------------
* No. Version Date      Revised by   Item      Description     
* 1   V1.0    02/18/2011                  
*****************************************************************/
void rfGetITStatus(void)
{
    //uiRfItStatus1 = spiReadAddrByte(InterruptStatus1);
    uiRfItStatus2 = spiReadAddrByte(InterruptStatus2);
}

/****************************************************************
 * Function Name: rfChannelCCA
 * Decription   : ͨ
 * Calls        : 
 * Called By    : 
 * Input        : None
 * Output       : None
 * Return Value : TRUE:ŵ FALSE:ŵæ
 * Others       : None
 *------------------------- Revision History -------------------
 * No. Version Date      Revised by   Item      Description     
 * 1   V1.0    02/18/2011                   
 *****************************************************************/
bool rfChannelCCA(void)
{
  #if 1   // ʽ1:ȡж״̬ĴRSSIλж
    rfGetITStatus();
    //DEBUG_PRINTF("\r\n RSSIֵ:%d, uiRfItStatus2:%d",spiReadAddrByte(ReceivedSignalStrengthIndicator),uiRfItStatus2);
    if(uiRfItStatus2&ABOVERSSI)
    {
        return FALSE;
    }
    else
    {
        return TRUE;
    }
  #else
    if(rfGetRssi() > RF_RSSI_THR)
        return FALSE;
    else
        return TRUE;
  #endif
}


/*******************************************************************************
*      : rfSetDeviation(uint32 dev)
*    : SI4432FSKͨŵƵƫý
*              
*    : fre - ĿƵʣλ1Hz625Hz,дhal_rf_set_deviation(625);
*    : 
*     ֵ : ý庬HAL_FUN_RETURN塣
*    : 
*        ע
*******************************************************************************/
bool rfSetDeviation(uint32 dev)
{
    uint16 fd;
    uint8 modeCtrl2;
    
    //鷶ΧǷ625Hz ~ 320KHz֮
    if ((dev < 625) || (dev > 320000))
    {
        return FALSE;
    }
    
    fd = (uint16)(dev / 625);
    
    //fd[8];
    modeCtrl2 = spiReadAddrByte(ModulationModeControl2);
    if (fd > 255)
    {
        modeCtrl2 |= 0x04;
    }
    spiWriteAddrByte(ModulationModeControl2, modeCtrl2);
    //fd[7:0]
    spiWriteAddrByte(FrequencyDeviation, fd);
    
    return TRUE;    
}

/****************************************************************
* Function Name: rfSetRfTxPower
* Decription   :÷书
* Calls        :
* Called By    :
* Input        :ĸȼPA_11DBM,PA_14DBM,PA_17DBM,PA_20DBM
* Output       :
* Return Value :
* Others       :
*------------------------- Revision History -------------------
* No. Version Date      Revised by   Item      Description     
* 1   V1.0    2011-2-18                   
*****************************************************************/ 
void rfSetTxPower(en_RfPower  rfpower)
{
    spiWriteAddrByte(TXPower, rfpower | 0x08);
}

/****************************************************************
* Function Name: rfSetFreq
* Decription   :
* Calls        :
* Called By    :
* Input        :4λʾƵ4λΪŵ
* Output       :
* Return Value :
* Others       :
*------------------------- Revision History -------------------
* No. Version Date      Revised by   Item      Description     
* 1   V1.0    02/18/2011                  
*****************************************************************/
void rfSetFreq(uint8 u8ChannelGrpFreq)
{   // Ƶ 481.0MHz
    spiWriteAddrByte(FrequencyBandSelect, 0x60);
    spiWriteAddrByte(NominalCarrierFrequency1, 0x0C);
    spiWriteAddrByte(NominalCarrierFrequency0, 0x80);
}

/****************************************************************
* Function Name: rfGetRssiTXPower
* Decription   :
* Calls        :
* Called By    :
* Input        :
* Output       :
* Return Value :
* Others       :
*------------------------- Revision History -------------------
* No. Version Date      Revised by   Item      Description     
* 1   V1.0    2011-2-18                   
*****************************************************************/
uint8 rfGetRssi(void)
{
    uint8 crssi_value;
    crssi_value = 129 - (spiReadAddrByte(ReceivedSignalStrengthIndicator)>>1);
    return crssi_value;
}

/****************************************************************
* Function Name: rfTx
* Decription   :
* Calls        :
* Called By    :
* Input        :2λʾƵ6λΪŵ
* Output       :
* Return Value :
* Others       :
*------------------------- Revision History -------------------
* No. Version Date      Revised by   Item      Description     
* 1   V1.0    02/18/2011                  
*****************************************************************/
uint8 rfTx(const uint8 *pbuf,uint8 u8Len)
{
    rfStop();                   // ֹͣRFշ
    rfSetFreq(0xFF);
    
    // PHY֡ͷ
    //rfBuf.Buf[RF_OFFSET_FREQ]       = u8Freq;    // PHYͷƷƵֽ
    //rfBuf.Buf[RF_OFFSET_PRODUCT_ID] = 0x01;      // PHYͷƷʶֽ
    rfBuf.Buf[RF_OFFSET_LEN]        = u8Len; // PHYͷֽ

    comMEMCPY(&rfBuf.Buf[RF_HEADER_LEN], pbuf, u8Len);
    rfBuf.Length = u8Len + RF_HEADER_LEN;
    
    rfSetPrmbleLength(20);
    rfStartTx();
    
    return 0;
}


